/* Connect.h - MyopicTopics.com Addin - part 4
 * Written By: Jason Weiler
 * This code is in the public domain
 */

// Connect.h : Declaration of the CConnect

#pragma once
#include "resource.h"       // main symbols

#include "DebuggerData.h"

using namespace AddInDesignerObjects;
using namespace EnvDTE;
using namespace EnvDTE80;

//*** Hooking debugger events ***/
class CConnect;
typedef IDispEventImpl<0, CConnect, &EnvDTE::DIID__dispDebuggerEvents, &EnvDTE::LIBID_EnvDTE, 8, 0> ConnectDebuggerEvents;
//*** Hooking debugger events ***/


/// <summary>The object for implementing an Add-in.</summary>
/// <seealso class='IDTExtensibility2' />
class ATL_NO_VTABLE CConnect : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CConnect, &CLSID_Connect>,
	public IDispatchImpl<_IDTExtensibility2, &IID__IDTExtensibility2, &LIBID_AddInDesignerObjects, 1, 0>,
//*** Hooking debugger events ***/
	public ConnectDebuggerEvents
//*** Hooking debugger events ***/
{
public:
	/// <summary>Implements the constructor for the Add-in object. Place your initialization code within this method.</summary>
	CConnect()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)
DECLARE_NOT_AGGREGATABLE(CConnect)


BEGIN_COM_MAP(CConnect)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IDTExtensibility2)
END_COM_MAP()

//*** Hooking debugger events ***/
BEGIN_SINK_MAP(CConnect)
//		SINK_ENTRY_EX(0, EnvDTE::DIID__dispDebuggerEvents, 1, OnEnterRunMode)
//		SINK_ENTRY_EX(0, EnvDTE::DIID__dispDebuggerEvents, 2, OnEnterDesignMode)
		SINK_ENTRY_EX(0, EnvDTE::DIID__dispDebuggerEvents, 3, OnEnterBreakMode)
//		SINK_ENTRY_EX(0, EnvDTE::DIID__dispDebuggerEvents, 4, OnExceptionThrown)
//		SINK_ENTRY_EX(0, EnvDTE::DIID__dispDebuggerEvents, 5, OnExceptionNotHandled)
//		SINK_ENTRY_EX(0, EnvDTE::DIID__dispDebuggerEvents, 6, OnContextChanged)
END_SINK_MAP()
//*** Hooking debugger events ***/

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
//IDTExtensibility2 implementation:

	/// <summary>Implements the OnConnection method of the IDTExtensibility2 interface. Receives notification that the Add-in is being loaded.</summary>
	/// <param term='application'>Root object of the host application.</param>
	/// <param term='connectMode'>Describes how the Add-in is being loaded.</param>
	/// <param term='addInInst'>Object representing this Add-in.</param>
	/// <seealso class='IDTExtensibility2' />
	STDMETHOD(OnConnection)(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom);

	/// <summary>Implements the OnDisconnection method of the IDTExtensibility2 interface. Receives notification that the Add-in is being unloaded.</summary>
	/// <param term='disconnectMode'>Describes how the Add-in is being unloaded.</param>
	/// <param term='custom'>Array of parameters that are host application specific.</param>
	/// <seealso class='IDTExtensibility2' />
	STDMETHOD(OnDisconnection)(ext_DisconnectMode RemoveMode, SAFEARRAY **custom );

	/// <summary>Implements the OnAddInsUpdate method of the IDTExtensibility2 interface. Receives notification when the collection of Add-ins has changed.</summary>
	/// <param term='custom'>Array of parameters that are host application specific.</param>
	/// <seealso class='IDTExtensibility2' />	
	STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom );

	/// <summary>Implements the OnStartupComplete method of the IDTExtensibility2 interface. Receives notification that the host application has completed loading.</summary>
	/// <param term='custom'>Array of parameters that are host application specific.</param>
	/// <seealso class='IDTExtensibility2' />
	STDMETHOD(OnStartupComplete)(SAFEARRAY **custom );

	/// <summary>Implements the OnBeginShutdown method of the IDTExtensibility2 interface. Receives notification that the host application is being unloaded.</summary>
	/// <param term='custom'>Array of parameters that are host application specific.</param>
	/// <seealso class='IDTExtensibility2' />
	STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom );
	

//*** Hooking debugger events ***/
	STDMETHOD(OnEnterBreakMode)(EnvDTE::dbgEventReason Reason, EnvDTE::dbgExecutionAction* ExecutionAction);
//*** Hooking debugger events ***/

public:
	bool QueryExpression(EnvDTE::Debugger * pDebugger , CComBSTR const & bsExpression , BSTR * bsOutValue);
	bool GetCurrentPID(EnvDTE::Debugger * pDebugger, long * lOutPID);

	// This needs to be static because the AutoExp.Dat code won't have a CConnect pointer.
	static DebuggerData s_DebuggerData;		

private:
	CComPtr<EnvDTE::_DebuggerEvents> m_pDebuggerEvents;
	CComPtr<DTE2> m_pDTE;
	CComPtr<AddIn> m_pAddInInstance;
};

OBJECT_ENTRY_AUTO(__uuidof(Connect), CConnect)
