/* DebuggerData.h - MyopicTopics.com Addin - part 4
 * Written By: Jason Weiler
 * This code is in the public domain
 */

#ifndef _DEBUGGERDATA_H_
#define _DEBUGGERDATA_H_

#include <atlbase.h>

// This function is defined inside of Connect.cpp. I put it over there to avoid some unfortunately header
//  inclusion if I put it in DebuggerData.cpp.
extern struct DebuggerData const & GetStaticDebuggerData();

struct DebuggerData
{
	DebuggerData()
	{
		ClearData();
	}

	void ClearData()
	{
		lCurrentPID = -1;
		SizeOfPointer = 0;
		SizeOfInteger = 0;
		MyTypeOffsetToStringIndex = 0;
		GlobalStringTableData = 0;
		GlobalStringTableMax = 0;
	}

	long lCurrentPID;

	unsigned long SizeOfPointer;
	unsigned long SizeOfInteger;
	unsigned long MyTypeOffsetToStringIndex;

	unsigned __int64 GlobalStringTableData;
	unsigned __int64 GlobalStringTableMax;
};

#endif // _DEBUGGERDATA_H_